/****************************************************************************
** Form interface generated from reading ui file 'qm_Player.ui'
**
** Created: 2012-12-11T10:59:32
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef QM_PLAYER_H
#define QM_PLAYER_H

#include <qvariant.h>
#include <qdialog.h>
#include <qtimer.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qevent.h>
#include <qfontmetrics.h>
#include <qsettings.h>
#include "qm_clicklabel.h"
#include "libmpdclient.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class clickLabel;
class clickprogressbar;
class QGroupBox;
class QLabel;
class QRadioButton;
class QPushButton;
class QSlider;

class qm_Player : public QDialog
{
    Q_OBJECT

public:
    qm_Player( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~qm_Player();

    QGroupBox* Display;
    QLabel* lb_extension;
    QLabel* lb_bitrate;
    QLabel* lb_totaltime;
    QGroupBox* mainTitleFrame;
    QLabel* lb_mainTitle;
    QLabel* lb_samplerate;
    QLabel* lb_kbps;
    clickLabel* lb_nowtime;
    QLabel* lb_kHz;
    QLabel* fr_aArt;
    QLabel* lb_album;
    QRadioButton* rb_repeat;
    QRadioButton* rb_random;
    QPushButton* bt_sizer;
    QSlider* sl_volume;
    QPushButton* bt_prev;
    QPushButton* bt_stop;
    QPushButton* bt_PlayPause;
    QPushButton* bt_next;
    QPushButton* bt_tracks;
    QPushButton* bt_opts;
    clickprogressbar* ds_progress;
    QLabel* px_status;

signals:
    void crToggleRepeat();
    void crToggleRandom();
    void crToggleOptions();
    void crToggleTracks();
    void crSendVolume(int);
    void crSendNext();
    void crSendPrev();
    void crSendPlay();
    void crSendStop();
    void crSendProgress(double);
    void crPlayerClosed();
    void crStoreTimeLeft(bool);
    void crTrayClicked(int);
    void crSetTrayTip(const QString &);

protected:

protected slots:
    virtual void languageChange();

private:
    QPixmap pauseIcon;
    QPixmap playIcon;
    QPixmap statPlay;
    QPixmap statStop;
    QPixmap statNocon;
    QPixmap statPause;
    QPixmap noPic;
    QPixmap onAir;
    QPixmap thePixmap;
    QImage theImage;
    QImage prevImage;
    QString Comment;
    QString curImage;
    QString albumArtString;
    int ScrollPos;
    int DisplayW;
    int curPlayStatus;
    int SongTitleW;
    int totalTime;
    int alphacycler;
    bool b_miniMode;
    bool b_lockProgress;
    bool b_playerSetsVolume;
    bool b_coreSetsVolume;
    bool b_volDisabled;
    bool b_timeLeft;
    bool b_plReallyClose;
    bool b_sRateFits;
    bool b_isStream;
    bool b_isArtString;
    bool b_xfadeWhenDone ;
    QTimer * TitleScroller;
    QTimer * crossFader;
    QTimer * windowSlider;

    void plSetDisplayColors(bool);
    void init();
    virtual void setupTitle( const QString & title );
    void getMusicPath();
    virtual void closeEvent( QCloseEvent * a );

private slots:
    virtual void plChangeStatus( int playStatus );
    virtual void plRedrawTitle(int titleFsize);
    virtual void plRedrawInfo(int infoFsize);
    virtual void plRedrawAlbum(int albumFsize);
    virtual void scrollStep();
    virtual void slideStep();
    virtual void xfadeStep();
    virtual void setVolume();
    virtual void setMinMaxMode();
    virtual void LockProgress(QMouseEvent *e);
    virtual void unLockProgress();
    virtual void plToggleTimeLeft();
    virtual void tRepeat();
    virtual void tRandom();
    virtual void tTracks();
    virtual void sOptions();
    virtual void sNext();
    virtual void sPrev();
    virtual void sPlay();
    virtual void sStop();
    virtual void plUpdate( int nowTime, int songBitrate, int songSamplerate );
    virtual void plNewSong( mpd_Song * aSong, int songNr );
    virtual void plSetRandom( bool value );
    virtual void plSetRepeat( bool value );
    virtual void plVolDisabled( bool value );
    virtual void plCoreSetVolume( int value );
    virtual void plReallyClose();
    virtual void plSetErrorMsg( const QString & Message );

};

#endif // QM_PLAYER_H
