#ifndef QM_LISTITEM
#define QM_LISTITEM

#include <qlistview.h>
#include <qdragobject.h>
#include <qpainter.h>
#include "libmpdclient.h"

#define LITEM_ROOT     0
#define LITEM_DIR      1
#define LITEM_TRACK    2
#define LITEM_ARTIST   3
#define LITEM_ALBUM    4
#define LITEM_PLAYLIST 5
#define LITEM_GENRE    6

#define LITEM_STAT_NORMAL  0
#define LITEM_STAT_CURRENT 1
#define LITEM_STAT_PAUSED  2
#define LITEM_STAT_STOPPED 3
#define LITEM_STAT_MESSAGE 4
#define LITEM_STAT_PLITEM  5
#define LITEM_STAT_HEADER  6


class Q_EXPORT qm_ListItem : public QListViewItem
{
 public:

////// DATABASEVIEW ///////

    qm_ListItem(QListView *parent, QString label, int iStatus = LITEM_STAT_HEADER);

    qm_ListItem ( QListViewItem *parent, mpd_Directory & theDir, QString label);

    qm_ListItem ( QListViewItem *parent, mpd_PlaylistFile & theList, QString label);

    qm_ListItem  ( QListViewItem *parent, QString label, int iStatus = LITEM_STAT_NORMAL);

    qm_ListItem  ( QListViewItem *parent, QListViewItem *after, QString label, int iStatus = LITEM_STAT_NORMAL);

    qm_ListItem ( QListViewItem *parent, mpd_Song & aSong, QString label);

/////// PLAYLISTVIEW ////////

    qm_ListItem ( QListView *parent, mpd_Song & aSong, QPixmap pxm, QString label1, QString label2 = QString::null, QString label3 = QString::null, QString label4 = QString::null);

    qm_ListItem ( QListView *parent, QListViewItem *after, mpd_Song & aSong, QPixmap pxm, QString label1, QString label2 = QString::null, QString label3 = QString::null, QString label4 = QString::null);

/////////////////////////////

    ~qm_ListItem();

    mpd_Song getSong();
    mpd_Directory getDir();
    mpd_PlaylistFile getList();
    virtual void paintCell( QPainter *p, const QColorGroup & cg, int column, int width, int align );
    void setDrawDropLine(char botom_no_top);
    char getDrawDropLine();
    void setWasPlayed(char hide_no_yes);
    char getWasPlayed();
    void setItemStatus(int iStatus);
    int getItemStatus();
    void setType(int type);
    int getType();
    void setArtist(const QString & artist);
    QString getArtist();
    void setAlbum(const QString & album);
    QString getAlbum();

 private:
    mpd_Song *theSong;
    mpd_Directory *theDir;
    mpd_PlaylistFile *theList;
    QString theAlbum;
    QString theArtist;
    char b3_wasPlayed; // -1 played & don't show, 0 not played, 1 played & show
    char b3_drawDropLine; // -1 bottom, 0 no, 1 default (top)
    int itemStatus;
    int itemType;
};

#endif
