#ifndef QM_LISTVIEW
#define QM_LISTVIEW

#include <qlistview.h>
#include <qdragobject.h>
#include "qm_ListItem.h"

#define LV_NONE     0
#define LV_DROP     1
#define LV_DRAG     2
#define LV_DRAGDROP 3

class Q_EXPORT qm_ListView : public QListView
{
    Q_OBJECT
 public:
    qm_ListView(QWidget *parent = 0, const char *name = 0);
    ~qm_ListView();
    void setType(int type);

 protected:
    void startDrag();
    void dragEnterEvent(QDragEnterEvent *e);
    void dragMoveEvent (QDragMoveEvent *e);
    void dragLeaveEvent (QDragLeaveEvent *e);
    void dropEvent(QDropEvent *e);
    void resizeEvent (QResizeEvent *e);

 private:
    int listType;
    qm_ListItem *dropLineItem;
    qm_ListItem *findItem(QPoint qp);
    void stopLineItem();

 signals:
    void recieveDrop(qm_ListView *source, qm_ListItem * pos);
    void resized(QResizeEvent *e);
};

#endif
